javax.xml.validation

## Class TypeInfoProvider

- java.lang.Object
- - javax.xml.validation.TypeInfoProvider

    public abstract class TypeInfoProvider
    extends java.lang.Object

This class provides access to the type information determined by `ValidatorHandler`.

Some schema languages, such as W3C XML Schema, encourages a validator to report the "type" it assigns to each attribute/element. Those applications who wish to access this type information can invoke methods defined on this "interface" to access such type information.

Implementation of this "interface" can be obtained through the `ValidatorHandler.getTypeInfoProvider()` method.

Since:
  1.5
Version:
  $Revision: 1.1 $, $Date: 2005/04/08 10:39:14 $
Author:
  Kohsuke Kawaguchi
See Also:
  `TypeInfo`

### Method Summary

Methods
`abstract TypeInfo` `getAttributeTypeInfo(int index)` Returns the immutable `TypeInfo` object for the specified attribute of the current element.
`abstract TypeInfo` `getElementTypeInfo()` Returns the immutable `TypeInfo` object for the current element.
`abstract boolean` `isIdAttribute(int index)` Returns `true` if the specified attribute is determined to be ID.
`abstract boolean` `isSpecified(int index)` Returns `false` if the attribute was added by the validator.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### getElementTypeInfo

    public abstract TypeInfo getElementTypeInfo()

Returns the immutable `TypeInfo` object for the current element.

The method may only be called by the startElement event of the `ContentHandler` that the application sets to the `ValidatorHandler`.

Returns:
  An immutable `TypeInfo` object that represents the type of the current element. Note that the caller can keep references to the obtained `TypeInfo` longer than the callback scope. Otherwise, this method returns null if the validator is unable to determine the type of the current element for some reason (for example, if the validator is recovering from an earlier error.)
Throws:
  `java.lang.IllegalStateException` - If this method is called from other `ContentHandler` methods.

#### getAttributeTypeInfo

    public abstract TypeInfo getAttributeTypeInfo(int index)

Returns the immutable `TypeInfo` object for the specified attribute of the current element.

The method may only be called by the startElement event of the `ContentHandler` that the application sets to the `ValidatorHandler`.

Parameters:
  `index` - The index of the attribute. The same index for the `Attributes` object passed to the `startElement` callback.
Returns:
  An immutable `TypeInfo` object that represents the type of the specified attribute. Note that the caller can keep references to the obtained `TypeInfo` longer than the callback scope. Otherwise, this method returns null if the validator is unable to determine the type.
Throws:
  `java.lang.IndexOutOfBoundsException` - If the index is invalid.
  `java.lang.IllegalStateException` - If this method is called from other `ContentHandler` methods.

#### isIdAttribute

    public abstract boolean isIdAttribute(int index)

Returns `true` if the specified attribute is determined to be ID.

Exacly how an attribute is "determined to be ID" is up to the schema language. In case of W3C XML Schema, this means that the actual type of the attribute is the built-in ID type or its derived type.

A `DocumentBuilder` uses this information to properly implement `Attr.isId()`.

The method may only be called by the startElement event of the `ContentHandler` that the application sets to the `ValidatorHandler`.

Parameters:
  `index` - The index of the attribute. The same index for the `Attributes` object passed to the `startElement` callback.
Returns:
  true if the type of the specified attribute is ID.
Throws:
  `java.lang.IndexOutOfBoundsException` - If the index is invalid.
  `java.lang.IllegalStateException` - If this method is called from other `ContentHandler` methods.

#### isSpecified

    public abstract boolean isSpecified(int index)

Returns `false` if the attribute was added by the validator.

This method provides information necessary for a `DocumentBuilder` to determine what the DOM tree should return from the `Attr.getSpecified()` method.

The method may only be called by the startElement event of the `ContentHandler` that the application sets to the `ValidatorHandler`.

A general guideline for validators is to return true if the attribute was originally present in the pipeline, and false if it was added by the validator.

Parameters:
  `index` - The index of the attribute. The same index for the `Attributes` object passed to the `startElement` callback.
Returns:
  `true` if the attribute was present before the validator processes input. `false` if the attribute was added by the validator.
Throws:
  `java.lang.IndexOutOfBoundsException` - If the index is invalid.
  `java.lang.IllegalStateException` - If this method is called from other `ContentHandler` methods.